diff -urN ../VisualBoyAdvance-1.7.2/src/arm-new.h ./src/arm-new.h
--- ../VisualBoyAdvance-1.7.2/src/arm-new.h	2004-05-13 22:57:11 +0900
+++ ./src/arm-new.h	2006-08-25 22:30:08 +0900
@@ -3835,38 +4720,47 @@
       u32 address = reg[base].I;
       CPUWriteMemory(address, reg[dest].I);
       reg[base].I = address + value;
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);
+      clockTicks = 2 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x700:
   case 0x708:
     {
       // STR Rd, [Rn, -Rm, LSL #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = reg[opcode & 15].I << ((opcode>>7)& 31);
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I - offset;
       CPUWriteMemory(address, reg[dest].I);
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);
+      clockTicks = 2 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x702:
   case 0x70a:
     {
       // STR Rd, [Rn, -Rm, LSR #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset = shift ? reg[opcode & 15].I >> shift : 0;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I - offset;
       CPUWriteMemory(address, reg[dest].I);
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);
+      clockTicks = 2 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x704:
   case 0x70c:
     {
       // STR Rd, [Rn, -Rm, ASR #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset;
       if(shift)
@@ -3879,13 +4773,16 @@
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I - offset;
       CPUWriteMemory(address, reg[dest].I);
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);
+      clockTicks = 2 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x706:
   case 0x70e:
     {
       // STR Rd, [Rn, -Rm, ROR #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       u32 value = reg[opcode & 15].I;
       if(shift) {
@@ -3897,26 +4794,32 @@
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I - value;
       CPUWriteMemory(address, reg[dest].I);
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);
+      clockTicks = 2 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x720:
   case 0x728:
     {
       // STR Rd, [Rn, -Rm, LSL #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = reg[opcode & 15].I << ((opcode>>7)& 31);
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I - offset;
       reg[base].I = address;
       CPUWriteMemory(address, reg[dest].I);
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);
+      clockTicks = 2 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x722:
   case 0x72a:
     {
       // STR Rd, [Rn, -Rm, LSR #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset = shift ? reg[opcode & 15].I >> shift : 0;
       int dest = (opcode >> 12) & 15;
@@ -3924,13 +4827,16 @@
       u32 address = reg[base].I - offset;
       reg[base].I = address;      
       CPUWriteMemory(address, reg[dest].I);
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);
+      clockTicks = 2 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x724:
   case 0x72c:
     {
       // STR Rd, [Rn, -Rm, ASR #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset;
       if(shift)
@@ -3944,13 +4850,16 @@
       u32 address = reg[base].I - offset;
       reg[base].I = address;
       CPUWriteMemory(address, reg[dest].I);
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);
+      clockTicks = 2 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x726:
   case 0x72e:
     {
       // STR Rd, [Rn, -Rm, ROR #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       u32 value = reg[opcode & 15].I;
       if(shift) {
@@ -3963,38 +4872,47 @@
       u32 address = reg[base].I - value;
       reg[base].I = address;      
       CPUWriteMemory(address, reg[dest].I);
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);
+      clockTicks = 2 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x780:
   case 0x788:
     {
       // STR Rd, [Rn, Rm, LSL #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = reg[opcode & 15].I << ((opcode>>7)& 31);
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I + offset;
       CPUWriteMemory(address, reg[dest].I);
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);
+      clockTicks = 2 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x782:
   case 0x78a:
     {
       // STR Rd, [Rn, Rm, LSR #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset = shift ? reg[opcode & 15].I >> shift : 0;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I + offset;
       CPUWriteMemory(address, reg[dest].I);
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);
+      clockTicks = 2 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x784:
   case 0x78c:
     {
       // STR Rd, [Rn, Rm, ASR #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset;
       if(shift)
@@ -4007,13 +4925,16 @@
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I + offset;
       CPUWriteMemory(address, reg[dest].I);
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);
+      clockTicks = 2 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x786:
   case 0x78e:
     {
       // STR Rd, [Rn, Rm, ROR #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       u32 value = reg[opcode & 15].I;
       if(shift) {
@@ -4025,26 +4946,32 @@
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I + value;
       CPUWriteMemory(address, reg[dest].I);
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);
+      clockTicks = 2 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x7a0:
   case 0x7a8:
     {
       // STR Rd, [Rn, Rm, LSL #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = reg[opcode & 15].I << ((opcode>>7)& 31);
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I + offset;
       reg[base].I = address;
       CPUWriteMemory(address, reg[dest].I);
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);
+      clockTicks = 2 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x7a2:
   case 0x7aa:
     {
       // STR Rd, [Rn, Rm, LSR #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset = shift ? reg[opcode & 15].I >> shift : 0;
       int dest = (opcode >> 12) & 15;
@@ -4052,13 +4979,16 @@
       u32 address = reg[base].I + offset;
       reg[base].I = address;      
       CPUWriteMemory(address, reg[dest].I);
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);
+      clockTicks = 2 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x7a4:
   case 0x7ac:
     {
       // STR Rd, [Rn, Rm, ASR #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset;
       if(shift)
@@ -4072,13 +5002,16 @@
       u32 address = reg[base].I + offset;
       reg[base].I = address;
       CPUWriteMemory(address, reg[dest].I);
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);
+      clockTicks = 2 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x7a6:
   case 0x7ae:
     {
       // STR Rd, [Rn, Rm, ROR #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       u32 value = reg[opcode & 15].I;
       if(shift) {
@@ -4091,7 +5024,8 @@
       u32 address = reg[base].I + value;
       reg[base].I = address;      
       CPUWriteMemory(address, reg[dest].I);
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);
+      clockTicks = 2 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x610:
@@ -4101,6 +5035,8 @@
   case 0x638:
     {
       // LDR Rd, [Rn], -Rm, LSL #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = reg[opcode & 15].I << ((opcode>>7)& 31);
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
@@ -4108,13 +5044,16 @@
       reg[dest].I = CPUReadMemory(address);
       if(dest != base)
         reg[base].I = address - offset;
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
       if(dest == 15) {
-        clockTicks += 2;
         reg[15].I &= 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
       }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x612:
@@ -4124,6 +5063,8 @@
   case 0x63a:
     {
       // LDR Rd, [Rn], -Rm, LSR #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset = shift ? reg[opcode & 15].I >> shift : 0;
       int dest = (opcode >> 12) & 15;
@@ -4132,13 +5073,16 @@
       reg[dest].I = CPUReadMemory(address);
       if(dest != base)
         reg[base].I = address - offset;
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
       if(dest == 15) {
-        clockTicks += 2;
         reg[15].I &= 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
       }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x614:
@@ -4148,6 +5092,8 @@
   case 0x63c:
     {
       // LDR Rd, [Rn], -Rm, ASR #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset;
       if(shift)
@@ -4162,13 +5108,16 @@
       reg[dest].I = CPUReadMemory(address);
       if(dest != base)
         reg[base].I = address - offset;
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
       if(dest == 15) {
-        clockTicks += 2;
         reg[15].I &= 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
       }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x616:
@@ -4178,6 +5127,8 @@
   case 0x63e:
     {
       // LDR Rd, [Rn], -Rm, ROR #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       u32 value = reg[opcode & 15].I;
       if(shift) {
@@ -4191,13 +5142,16 @@
       reg[dest].I = CPUReadMemory(address);
       if(dest != base)
         reg[base].I = address - value;
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
       if(dest == 15) {
-        clockTicks += 2;
         reg[15].I &= 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
       }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x690:
@@ -4207,6 +5161,8 @@
   case 0x6b8:
     {
       // LDR Rd, [Rn], Rm, LSL #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = reg[opcode & 15].I << ((opcode>>7)& 31);
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
@@ -4214,13 +5170,16 @@
       reg[dest].I = CPUReadMemory(address);
       if(dest != base)
         reg[base].I = address + offset;
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
       if(dest == 15) {
-        clockTicks += 2;
         reg[15].I &= 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
       }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x692:
@@ -4230,6 +5189,8 @@
   case 0x6ba:
     {
       // LDR Rd, [Rn], Rm, LSR #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset = shift ? reg[opcode & 15].I >> shift : 0;
       int dest = (opcode >> 12) & 15;
@@ -4238,13 +5199,16 @@
       reg[dest].I = CPUReadMemory(address);
       if(dest != base)
         reg[base].I = address + offset;
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
       if(dest == 15) {
-        clockTicks += 2;
         reg[15].I &= 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
       }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x694:
@@ -4254,6 +5218,8 @@
   case 0x6bc:
     {
       // LDR Rd, [Rn], Rm, ASR #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset;
       if(shift)
@@ -4268,13 +5234,16 @@
       reg[dest].I = CPUReadMemory(address);
       if(dest != base)
         reg[base].I = address + offset;
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
       if(dest == 15) {
-        clockTicks += 2;
         reg[15].I &= 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
       }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x696:
@@ -4284,6 +5253,8 @@
   case 0x6be:
     {
       // LDR Rd, [Rn], Rm, ROR #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       u32 value = reg[opcode & 15].I;
       if(shift) {
@@ -4297,56 +5268,71 @@
       reg[dest].I = CPUReadMemory(address);
       if(dest != base)
         reg[base].I = address + value;
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
       if(dest == 15) {
-        clockTicks += 2;
         reg[15].I &= 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
       }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x710:
   case 0x718:
     {
       // LDR Rd, [Rn, -Rm, LSL #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = reg[opcode & 15].I << ((opcode>>7)& 31);
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I - offset;
       reg[dest].I = CPUReadMemory(address);
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
       if(dest == 15) {
-        clockTicks += 2;
         reg[15].I &= 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
       }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x712:
   case 0x71a:
     {
       // LDR Rd, [Rn, -Rm, LSR #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset = shift ? reg[opcode & 15].I >> shift : 0;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I - offset;
       reg[dest].I = CPUReadMemory(address);
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
       if(dest == 15) {
-        clockTicks += 2;
         reg[15].I &= 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
       }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x714:
   case 0x71c:
     {
       // LDR Rd, [Rn, -Rm, ASR #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset;
       if(shift)
@@ -4359,19 +5345,24 @@
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I - offset;
       reg[dest].I = CPUReadMemory(address);
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
       if(dest == 15) {
-        clockTicks += 2;
         reg[15].I &= 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
       }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x716:
   case 0x71e:
     {
       // LDR Rd, [Rn, -Rm, ROR #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       u32 value = reg[opcode & 15].I;
       if(shift) {
@@ -4383,19 +5374,24 @@
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I - value;
       reg[dest].I = CPUReadMemory(address);
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
       if(dest == 15) {
-        clockTicks += 2;
         reg[15].I &= 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
       }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x730:
   case 0x738:
     {
       // LDR Rd, [Rn, -Rm, LSL #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = reg[opcode & 15].I << ((opcode>>7)& 31);
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
@@ -4403,19 +5399,24 @@
       reg[dest].I = CPUReadMemory(address);
       if(dest != base)
         reg[base].I = address;
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
       if(dest == 15) {
-        clockTicks += 2;
         reg[15].I &= 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
       }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x732:
   case 0x73a:
     {
       // LDR Rd, [Rn, -Rm, LSR #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset = shift ? reg[opcode & 15].I >> shift : 0;
       int dest = (opcode >> 12) & 15;
@@ -4424,19 +5425,24 @@
       reg[dest].I = CPUReadMemory(address);
       if(dest != base)
         reg[base].I = address;      
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
       if(dest == 15) {
-        clockTicks += 2;
         reg[15].I &= 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
       }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x734:
   case 0x73c:
     {
       // LDR Rd, [Rn, -Rm, ASR #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset;
       if(shift)
@@ -4451,19 +5457,24 @@
       reg[dest].I = CPUReadMemory(address);
       if(dest != base)
         reg[base].I = address;
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
       if(dest == 15) {
-        clockTicks += 2;
         reg[15].I &= 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
       }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x736:
   case 0x73e:
     {
       // LDR Rd, [Rn, -Rm, ROR #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       u32 value = reg[opcode & 15].I;
       if(shift) {
@@ -4477,56 +5488,71 @@
       reg[dest].I = CPUReadMemory(address);
       if(dest != base)
         reg[base].I = address;      
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
       if(dest == 15) {
-        clockTicks += 2;
         reg[15].I &= 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
       }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x790:
   case 0x798:
     {
       // LDR Rd, [Rn, Rm, LSL #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = reg[opcode & 15].I << ((opcode>>7)& 31);
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I + offset;
       reg[dest].I = CPUReadMemory(address);
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
       if(dest == 15) {
-        clockTicks += 2;
         reg[15].I &= 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
       }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x792:
   case 0x79a:
     {
       // LDR Rd, [Rn, Rm, LSR #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset = shift ? reg[opcode & 15].I >> shift : 0;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I + offset;
       reg[dest].I = CPUReadMemory(address);
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
       if(dest == 15) {
-        clockTicks += 2;
         reg[15].I &= 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
       }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x794:
   case 0x79c:
     {
       // LDR Rd, [Rn, Rm, ASR #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset;
       if(shift)
@@ -4539,19 +5565,24 @@
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I + offset;
       reg[dest].I = CPUReadMemory(address);
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
       if(dest == 15) {
-        clockTicks += 2;
         reg[15].I &= 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
       }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x796:
   case 0x79e:
     {
       // LDR Rd, [Rn, Rm, ROR #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       u32 value = reg[opcode & 15].I;
       if(shift) {
@@ -4563,19 +5594,24 @@
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I + value;
       reg[dest].I = CPUReadMemory(address);
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
       if(dest == 15) {
-        clockTicks += 2;
         reg[15].I &= 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
       }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x7b0:
   case 0x7b8:
     {
       // LDR Rd, [Rn, Rm, LSL #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = reg[opcode & 15].I << ((opcode>>7)& 31);
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
@@ -4583,19 +5619,24 @@
       reg[dest].I = CPUReadMemory(address);
       if(dest != base)
         reg[base].I = address;
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
       if(dest == 15) {
-        clockTicks += 2;
         reg[15].I &= 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
       }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x7b2:
   case 0x7ba:
     {
       // LDR Rd, [Rn, Rm, LSR #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset = shift ? reg[opcode & 15].I >> shift : 0;
       int dest = (opcode >> 12) & 15;
@@ -4604,19 +5645,24 @@
       reg[dest].I = CPUReadMemory(address);
       if(dest != base)
         reg[base].I = address;      
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
       if(dest == 15) {
-        clockTicks += 2;
         reg[15].I &= 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
       }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x7b4:
   case 0x7bc:
     {
       // LDR Rd, [Rn, Rm, ASR #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset;
       if(shift)
@@ -4631,19 +5677,24 @@
       reg[dest].I = CPUReadMemory(address);
       if(dest != base)
         reg[base].I = address;
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
       if(dest == 15) {
-        clockTicks += 2;
         reg[15].I &= 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
       }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x7b6:
   case 0x7be:
     {
       // LDR Rd, [Rn, Rm, ROR #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       u32 value = reg[opcode & 15].I;
       if(shift) {
@@ -4657,13 +5708,16 @@
       reg[dest].I = CPUReadMemory(address);
       if(dest != base)
         reg[base].I = address;
-      clockTicks += 3 + CPUUpdateTicksAccess32(address);
+      clockTicks = 0;
       if(dest == 15) {
-        clockTicks += 2;
         reg[15].I &= 0xFFFFFFFC;
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
       }
+      clockTicks += 3 + dataTicksAccess32(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x640:
@@ -4673,13 +5727,16 @@
   case 0x668:
     {
       // STRB Rd, [Rn], -Rm, LSL #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = reg[opcode & 15].I << ((opcode>>7)& 31);
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I;
       CPUWriteByte(address, reg[dest].B.B0);
       reg[base].I = address - offset;
-      clockTicks += 2 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x642:
@@ -4689,6 +5746,8 @@
   case 0x66a:
     {
       // STRB Rd, [Rn], -Rm, LSR #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset = shift ? reg[opcode & 15].I >> shift : 0;
       int dest = (opcode >> 12) & 15;
@@ -4696,7 +5755,8 @@
       u32 address = reg[base].I;
       CPUWriteByte(address, reg[dest].B.B0);
       reg[base].I = address - offset;
-      clockTicks += 2 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x644:
@@ -4706,6 +5766,8 @@
   case 0x66c:
     {
       // STRB Rd, [Rn], -Rm, ASR #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset;
       if(shift)
@@ -4719,7 +5781,8 @@
       u32 address = reg[base].I;
       CPUWriteByte(address, reg[dest].B.B0);
       reg[base].I = address - offset;
-      clockTicks += 2 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x646:
@@ -4729,6 +5792,8 @@
   case 0x66e:
     {
       // STRB Rd, [Rn], -Rm, ROR #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       u32 value = reg[opcode & 15].I;
       if(shift) {
